// generated by "charlatan -dir=testdata/array -output=testdata/array/array.go Array".  DO NOT EDIT.

package main

import (
	"reflect"
	"testing"
)

// ArrayParameterInvocation represents a single call of FakeArray.ArrayParameter
type ArrayParameterInvocation struct {
	Parameters struct {
		Ident1 [3]string
	}
}

// ArrayReturnInvocation represents a single call of FakeArray.ArrayReturn
type ArrayReturnInvocation struct {
	Results struct {
		Ident2 [3]string
	}
}

// SliceParameterInvocation represents a single call of FakeArray.SliceParameter
type SliceParameterInvocation struct {
	Parameters struct {
		Ident3 []string
	}
}

// SliceReturnInvocation represents a single call of FakeArray.SliceReturn
type SliceReturnInvocation struct {
	Results struct {
		Ident4 []string
	}
}

/*
FakeArray is a mock implementation of Array for testing.
Use it in your tests as in this example:

	package example

	func TestWithArray(t *testing.T) {
		f := &main.FakeArray{
			ArrayParameterHook: func(ident1 [3]string) () {
				// ensure parameters meet expections, signal errors using t, etc
				return
			},
		}

		// test code goes here ...

		// assert state of FakeArrayParameter ...
		f.AssertArrayParameterCalledOnce(t)
	}

Create anonymous function implementations for only those interface methods that
should be called in the code under test.  This will force a panic if any
unexpected calls are made to FakeArrayParameter.
*/
type FakeArray struct {
	ArrayParameterHook func([3]string)
	ArrayReturnHook    func() [3]string
	SliceParameterHook func([]string)
	SliceReturnHook    func() []string

	ArrayParameterCalls []*ArrayParameterInvocation
	ArrayReturnCalls    []*ArrayReturnInvocation
	SliceParameterCalls []*SliceParameterInvocation
	SliceReturnCalls    []*SliceReturnInvocation
}

// NewFakeArrayDefaultPanic returns an instance of FakeArray with all hooks configured to panic
func NewFakeArrayDefaultPanic() *FakeArray {
	return &FakeArray{
		ArrayParameterHook: func([3]string) {
			panic("Unexpected call to Array.ArrayParameter")
		},
		ArrayReturnHook: func() (ident2 [3]string) {
			panic("Unexpected call to Array.ArrayReturn")
		},
		SliceParameterHook: func([]string) {
			panic("Unexpected call to Array.SliceParameter")
		},
		SliceReturnHook: func() (ident4 []string) {
			panic("Unexpected call to Array.SliceReturn")
		},
	}
}

// NewFakeArrayDefaultFatal returns an instance of FakeArray with all hooks configured to call t.Fatal
func NewFakeArrayDefaultFatal(t *testing.T) *FakeArray {
	return &FakeArray{
		ArrayParameterHook: func([3]string) {
			t.Fatal("Unexpected call to Array.ArrayParameter")
			return
		},
		ArrayReturnHook: func() (ident2 [3]string) {
			t.Fatal("Unexpected call to Array.ArrayReturn")
			return
		},
		SliceParameterHook: func([]string) {
			t.Fatal("Unexpected call to Array.SliceParameter")
			return
		},
		SliceReturnHook: func() (ident4 []string) {
			t.Fatal("Unexpected call to Array.SliceReturn")
			return
		},
	}
}

// NewFakeArrayDefaultError returns an instance of FakeArray with all hooks configured to call t.Error
func NewFakeArrayDefaultError(t *testing.T) *FakeArray {
	return &FakeArray{
		ArrayParameterHook: func([3]string) {
			t.Error("Unexpected call to Array.ArrayParameter")
			return
		},
		ArrayReturnHook: func() (ident2 [3]string) {
			t.Error("Unexpected call to Array.ArrayReturn")
			return
		},
		SliceParameterHook: func([]string) {
			t.Error("Unexpected call to Array.SliceParameter")
			return
		},
		SliceReturnHook: func() (ident4 []string) {
			t.Error("Unexpected call to Array.SliceReturn")
			return
		},
	}
}

func (_f1 *FakeArray) ArrayParameter(ident1 [3]string) {
	invocation := new(ArrayParameterInvocation)

	invocation.Parameters.Ident1 = ident1

	_f1.ArrayParameterHook(ident1)

	_f1.ArrayParameterCalls = append(_f1.ArrayParameterCalls, invocation)

	return
}

// ArrayParameterCalled returns true if FakeArray.ArrayParameter was called
func (f *FakeArray) ArrayParameterCalled() bool {
	return len(f.ArrayParameterCalls) != 0
}

// AssertArrayParameterCalled calls t.Error if FakeArray.ArrayParameter was not called
func (f *FakeArray) AssertArrayParameterCalled(t *testing.T) {
	t.Helper()
	if len(f.ArrayParameterCalls) == 0 {
		t.Error("FakeArray.ArrayParameter not called, expected at least one")
	}
}

// ArrayParameterNotCalled returns true if FakeArray.ArrayParameter was not called
func (f *FakeArray) ArrayParameterNotCalled() bool {
	return len(f.ArrayParameterCalls) == 0
}

// AssertArrayParameterNotCalled calls t.Error if FakeArray.ArrayParameter was called
func (f *FakeArray) AssertArrayParameterNotCalled(t *testing.T) {
	t.Helper()
	if len(f.ArrayParameterCalls) != 0 {
		t.Error("FakeArray.ArrayParameter called, expected none")
	}
}

// ArrayParameterCalledOnce returns true if FakeArray.ArrayParameter was called exactly once
func (f *FakeArray) ArrayParameterCalledOnce() bool {
	return len(f.ArrayParameterCalls) == 1
}

// AssertArrayParameterCalledOnce calls t.Error if FakeArray.ArrayParameter was not called exactly once
func (f *FakeArray) AssertArrayParameterCalledOnce(t *testing.T) {
	t.Helper()
	if len(f.ArrayParameterCalls) != 1 {
		t.Errorf("FakeArray.ArrayParameter called %d times, expected 1", len(f.ArrayParameterCalls))
	}
}

// ArrayParameterCalledN returns true if FakeArray.ArrayParameter was called at least n times
func (f *FakeArray) ArrayParameterCalledN(n int) bool {
	return len(f.ArrayParameterCalls) >= n
}

// AssertArrayParameterCalledN calls t.Error if FakeArray.ArrayParameter was called less than n times
func (f *FakeArray) AssertArrayParameterCalledN(t *testing.T, n int) {
	t.Helper()
	if len(f.ArrayParameterCalls) < n {
		t.Errorf("FakeArray.ArrayParameter called %d times, expected >= %d", len(f.ArrayParameterCalls), n)
	}
}

// ArrayParameterCalledWith returns true if FakeArray.ArrayParameter was called with the given values
func (_f2 *FakeArray) ArrayParameterCalledWith(ident1 [3]string) (found bool) {
	for _, call := range _f2.ArrayParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertArrayParameterCalledWith calls t.Error if FakeArray.ArrayParameter was not called with the given values
func (_f3 *FakeArray) AssertArrayParameterCalledWith(t *testing.T, ident1 [3]string) {
	t.Helper()
	var found bool
	for _, call := range _f3.ArrayParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeArray.ArrayParameter not called with expected parameters")
	}
}

// ArrayParameterCalledOnceWith returns true if FakeArray.ArrayParameter was called exactly once with the given values
func (_f4 *FakeArray) ArrayParameterCalledOnceWith(ident1 [3]string) bool {
	var count int
	for _, call := range _f4.ArrayParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertArrayParameterCalledOnceWith calls t.Error if FakeArray.ArrayParameter was not called exactly once with the given values
func (_f5 *FakeArray) AssertArrayParameterCalledOnceWith(t *testing.T, ident1 [3]string) {
	t.Helper()
	var count int
	for _, call := range _f5.ArrayParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeArray.ArrayParameter called %d times with expected parameters, expected one", count)
	}
}

func (_f6 *FakeArray) ArrayReturn() (ident2 [3]string) {
	invocation := new(ArrayReturnInvocation)

	ident2 = _f6.ArrayReturnHook()

	invocation.Results.Ident2 = ident2

	_f6.ArrayReturnCalls = append(_f6.ArrayReturnCalls, invocation)

	return
}

// ArrayReturnCalled returns true if FakeArray.ArrayReturn was called
func (f *FakeArray) ArrayReturnCalled() bool {
	return len(f.ArrayReturnCalls) != 0
}

// AssertArrayReturnCalled calls t.Error if FakeArray.ArrayReturn was not called
func (f *FakeArray) AssertArrayReturnCalled(t *testing.T) {
	t.Helper()
	if len(f.ArrayReturnCalls) == 0 {
		t.Error("FakeArray.ArrayReturn not called, expected at least one")
	}
}

// ArrayReturnNotCalled returns true if FakeArray.ArrayReturn was not called
func (f *FakeArray) ArrayReturnNotCalled() bool {
	return len(f.ArrayReturnCalls) == 0
}

// AssertArrayReturnNotCalled calls t.Error if FakeArray.ArrayReturn was called
func (f *FakeArray) AssertArrayReturnNotCalled(t *testing.T) {
	t.Helper()
	if len(f.ArrayReturnCalls) != 0 {
		t.Error("FakeArray.ArrayReturn called, expected none")
	}
}

// ArrayReturnCalledOnce returns true if FakeArray.ArrayReturn was called exactly once
func (f *FakeArray) ArrayReturnCalledOnce() bool {
	return len(f.ArrayReturnCalls) == 1
}

// AssertArrayReturnCalledOnce calls t.Error if FakeArray.ArrayReturn was not called exactly once
func (f *FakeArray) AssertArrayReturnCalledOnce(t *testing.T) {
	t.Helper()
	if len(f.ArrayReturnCalls) != 1 {
		t.Errorf("FakeArray.ArrayReturn called %d times, expected 1", len(f.ArrayReturnCalls))
	}
}

// ArrayReturnCalledN returns true if FakeArray.ArrayReturn was called at least n times
func (f *FakeArray) ArrayReturnCalledN(n int) bool {
	return len(f.ArrayReturnCalls) >= n
}

// AssertArrayReturnCalledN calls t.Error if FakeArray.ArrayReturn was called less than n times
func (f *FakeArray) AssertArrayReturnCalledN(t *testing.T, n int) {
	t.Helper()
	if len(f.ArrayReturnCalls) < n {
		t.Errorf("FakeArray.ArrayReturn called %d times, expected >= %d", len(f.ArrayReturnCalls), n)
	}
}

func (_f7 *FakeArray) SliceParameter(ident3 []string) {
	invocation := new(SliceParameterInvocation)

	invocation.Parameters.Ident3 = ident3

	_f7.SliceParameterHook(ident3)

	_f7.SliceParameterCalls = append(_f7.SliceParameterCalls, invocation)

	return
}

// SliceParameterCalled returns true if FakeArray.SliceParameter was called
func (f *FakeArray) SliceParameterCalled() bool {
	return len(f.SliceParameterCalls) != 0
}

// AssertSliceParameterCalled calls t.Error if FakeArray.SliceParameter was not called
func (f *FakeArray) AssertSliceParameterCalled(t *testing.T) {
	t.Helper()
	if len(f.SliceParameterCalls) == 0 {
		t.Error("FakeArray.SliceParameter not called, expected at least one")
	}
}

// SliceParameterNotCalled returns true if FakeArray.SliceParameter was not called
func (f *FakeArray) SliceParameterNotCalled() bool {
	return len(f.SliceParameterCalls) == 0
}

// AssertSliceParameterNotCalled calls t.Error if FakeArray.SliceParameter was called
func (f *FakeArray) AssertSliceParameterNotCalled(t *testing.T) {
	t.Helper()
	if len(f.SliceParameterCalls) != 0 {
		t.Error("FakeArray.SliceParameter called, expected none")
	}
}

// SliceParameterCalledOnce returns true if FakeArray.SliceParameter was called exactly once
func (f *FakeArray) SliceParameterCalledOnce() bool {
	return len(f.SliceParameterCalls) == 1
}

// AssertSliceParameterCalledOnce calls t.Error if FakeArray.SliceParameter was not called exactly once
func (f *FakeArray) AssertSliceParameterCalledOnce(t *testing.T) {
	t.Helper()
	if len(f.SliceParameterCalls) != 1 {
		t.Errorf("FakeArray.SliceParameter called %d times, expected 1", len(f.SliceParameterCalls))
	}
}

// SliceParameterCalledN returns true if FakeArray.SliceParameter was called at least n times
func (f *FakeArray) SliceParameterCalledN(n int) bool {
	return len(f.SliceParameterCalls) >= n
}

// AssertSliceParameterCalledN calls t.Error if FakeArray.SliceParameter was called less than n times
func (f *FakeArray) AssertSliceParameterCalledN(t *testing.T, n int) {
	t.Helper()
	if len(f.SliceParameterCalls) < n {
		t.Errorf("FakeArray.SliceParameter called %d times, expected >= %d", len(f.SliceParameterCalls), n)
	}
}

// SliceParameterCalledWith returns true if FakeArray.SliceParameter was called with the given values
func (_f8 *FakeArray) SliceParameterCalledWith(ident3 []string) (found bool) {
	for _, call := range _f8.SliceParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident3, ident3) {
			found = true
			break
		}
	}

	return
}

// AssertSliceParameterCalledWith calls t.Error if FakeArray.SliceParameter was not called with the given values
func (_f9 *FakeArray) AssertSliceParameterCalledWith(t *testing.T, ident3 []string) {
	t.Helper()
	var found bool
	for _, call := range _f9.SliceParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident3, ident3) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeArray.SliceParameter not called with expected parameters")
	}
}

// SliceParameterCalledOnceWith returns true if FakeArray.SliceParameter was called exactly once with the given values
func (_f10 *FakeArray) SliceParameterCalledOnceWith(ident3 []string) bool {
	var count int
	for _, call := range _f10.SliceParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident3, ident3) {
			count++
		}
	}

	return count == 1
}

// AssertSliceParameterCalledOnceWith calls t.Error if FakeArray.SliceParameter was not called exactly once with the given values
func (_f11 *FakeArray) AssertSliceParameterCalledOnceWith(t *testing.T, ident3 []string) {
	t.Helper()
	var count int
	for _, call := range _f11.SliceParameterCalls {
		if reflect.DeepEqual(call.Parameters.Ident3, ident3) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeArray.SliceParameter called %d times with expected parameters, expected one", count)
	}
}

func (_f12 *FakeArray) SliceReturn() (ident4 []string) {
	invocation := new(SliceReturnInvocation)

	ident4 = _f12.SliceReturnHook()

	invocation.Results.Ident4 = ident4

	_f12.SliceReturnCalls = append(_f12.SliceReturnCalls, invocation)

	return
}

// SliceReturnCalled returns true if FakeArray.SliceReturn was called
func (f *FakeArray) SliceReturnCalled() bool {
	return len(f.SliceReturnCalls) != 0
}

// AssertSliceReturnCalled calls t.Error if FakeArray.SliceReturn was not called
func (f *FakeArray) AssertSliceReturnCalled(t *testing.T) {
	t.Helper()
	if len(f.SliceReturnCalls) == 0 {
		t.Error("FakeArray.SliceReturn not called, expected at least one")
	}
}

// SliceReturnNotCalled returns true if FakeArray.SliceReturn was not called
func (f *FakeArray) SliceReturnNotCalled() bool {
	return len(f.SliceReturnCalls) == 0
}

// AssertSliceReturnNotCalled calls t.Error if FakeArray.SliceReturn was called
func (f *FakeArray) AssertSliceReturnNotCalled(t *testing.T) {
	t.Helper()
	if len(f.SliceReturnCalls) != 0 {
		t.Error("FakeArray.SliceReturn called, expected none")
	}
}

// SliceReturnCalledOnce returns true if FakeArray.SliceReturn was called exactly once
func (f *FakeArray) SliceReturnCalledOnce() bool {
	return len(f.SliceReturnCalls) == 1
}

// AssertSliceReturnCalledOnce calls t.Error if FakeArray.SliceReturn was not called exactly once
func (f *FakeArray) AssertSliceReturnCalledOnce(t *testing.T) {
	t.Helper()
	if len(f.SliceReturnCalls) != 1 {
		t.Errorf("FakeArray.SliceReturn called %d times, expected 1", len(f.SliceReturnCalls))
	}
}

// SliceReturnCalledN returns true if FakeArray.SliceReturn was called at least n times
func (f *FakeArray) SliceReturnCalledN(n int) bool {
	return len(f.SliceReturnCalls) >= n
}

// AssertSliceReturnCalledN calls t.Error if FakeArray.SliceReturn was called less than n times
func (f *FakeArray) AssertSliceReturnCalledN(t *testing.T, n int) {
	t.Helper()
	if len(f.SliceReturnCalls) < n {
		t.Errorf("FakeArray.SliceReturn called %d times, expected >= %d", len(f.SliceReturnCalls), n)
	}
}
